<? // Main Engine for System V1.0 - FMS V5

include_once("./config.inc.php");
include_once(LOCAL_INCLUDES."/mainclass.inc.php");
include_once(LOCAL_INCLUDES."/hookclass.inc.php");

$requested_page	= $_SERVER['REQUEST_URI'];
$domain_name	= $_SERVER['HTTP_HOST'];

// GET DOMAIN NAME AND OTHER INFORMATION.
if(DOMAIN_TYPE == true)
{
	if(preg_match("/www\./", $domain_name)) : 
	define('THIS_DOMAIN', $domain_name); 
	else: 
		ignore_user_abort(true);
		header ("Pragma: no-cache");
		header("Cache-Control: no-store, no-cache, must-revalidate");
		header("HTTP/1.1 301 Moved Permanently");
		header("Location: http://www.$domain_name$requested_page"); 
		header("Connection: close");
		exit;
	endif;
} else {
	define('THIS_DOMAIN', $domain_name); 	
}

switch($requested_page) :
	case '/':
		define('THIS_PAGE', 'index');
	break;
	case '/index.html':
		define('THIS_PAGE', 'index');
	break;
	case '/sitemap.html':
		define('THIS_PAGE', 'sitemap');
	break;
	default:
		define('THIS_PAGE', 'results');
endswitch;

// CHECK FOR ATTEMPTS TO INSERT HTML, JAVASCRIPT, CSS, PHP, ETC
if(stristr($requested_page, '>') OR stristr($requested_page, '<') ) Give404($requested_page);
// GET FILE NAME FOR KEYWORD
$page_keyword = str_replace("-", " ", substr($requested_page, 1, -5));

// CHECK TO SEE IF PAGE IS IN ARCHIVES OR KEYWORD FILE, IF NOT GIVE 404.
if(THIS_PAGE != 'index' && THIS_PAGE != 'sitemap') :
	if(!file_exists(LOCAL_CACHE.THIS_PAGE.CACHE_FORMAT) && !preg_match("/$page_keyword/", @file_get_contents(FILE_KEYWORDS))) Give404($requested_page);
endif;

// LOAD THE TEMPLATES AND LET THEM TAKE OVER FROM HERE.
include_once(LOCAL_TEMPLATE.THIS_PAGE.TEMPLAT_FORMAT);
?>