<?
/*
A modded version of the RSSGM project Markov script. 
Some improvements for better results, and to work with MyGen. 

INSTALL
make a folder called articles in your domain root, 
then upload this file to your hook folder. 
Add some txt files with text in the article folder and there you have it.

TO USE: <? markov(3, 150); ?>
*/
function markov($gran,$numwords){

if (is_dir("./articles/")) {
   if ($dh = opendir("./articles/")) {
       while (($file = readdir($dh)) !== false) {
       
       	    if($file == "." || $file == ".." || empty($file)){$my_dump[] = $file;}
       	    elseif(substr($file, -4) == '.txt'){
			 $combo .= file_get_contents("./articles/".$file);
       	    }
       	     if($i >= $nr_files){$i = 0;} elseif($i < $nr_files){
        ++$i; }
       }
       closedir($dh);
   }
}
	$combo = explode("\n", $combo);
	shuffle($combo);
	$combo = implode(' ', $combo);
	
	$G = $gran;
	$O = $numwords;
	$output ="";
	$combo = $combo;
	//Set number of letters per line in output
	$LETTERS_LINE = 65;
	
	$textwords = array();
	$textwords = explode(" ", $combo);
	
	$loopmax = count($textwords) - ($G - 2) - 1;
	
	$frequency_table = array();
	
	for ($j = 0; $j < $loopmax; $j++) {
	$key_string = "";
	$end = $j + $G;
	for ($k = $j; $k < $end; $k++) {
	//build the key string (G - 1) words
	$key_string .= $textwords[$k] . ' ';
	}
	$frequency_table[$key_string] .= $textwords[$j + $G] . " ";
	
	}
	
	$buffer="";
	$lastwords = array();
	
	for ($i = 0; $i < $G; $i ++) {
	$lastwords[] = $textwords[$i];
	$buffer .= " " . $textwords[$i];
	}
	
	for ($i = 0; $i < $O; $i++){
	$key_string = "";   
	for ($j = 0; $j < $G; $j++) {
	$key_string .= $lastwords[$j] . " ";
	}
	if ($frequency_table[$key_string]){
	$possible = explode(" ", trim($frequency_table[$key_string]));
	mt_srand();
	$c = count($possible);
	$r = mt_rand(1, $c) -1;
	$nextword = $possible[$r];
	$buffer .= " $nextword";
	if(strlen($buffer) >= $LETTERS_LINE) {
	//echo $buffer . "\n";
	$output .= $buffer;
	$buffer = "";
	}
	for($l = 0; $l < $G - 1; $l++){ 
	$lastwords[$l] = $lastwords[$l+1]; 
	}
	$lastwords[$G - 1] = $nextword;
	}
	else{    
	$lastwords = array_splice($lastwords, 0, count($lastwords));
	for ($l = 0; $l < $G; $l++) {
	$lastwords[] = $textwords[$l]; 
	$buffer .= ' ' . $textwords[$l];
	}
	}
	}
	//if((strlen($buffer)) > 0) {
	// $output = $buffer;
	//}
	print $output;
}
?>